      program romberg
      
      real*8 a,b,eps,c,d,h,t(100,100),r(100,100),e(100) 
      real*8 v,pi,f,z,w
      integer i,n,k,kmax
      parameter (a=0,b=4,d=0,kmax=12,eps=5e-9)
            
      open(17,file='resul2.txt',status='unknown')
      
      pi=acos(-1.)
      c=pi/4
      h=b-a
      call g(a,d,c,z)
      call g(b,d,c,w)
c     Calculamos f(a) y f(b), para poder calcular t(0,0)
      t(0,0)=h*(z+w)/2
      e(1)=3
      
      do k=1,kmax
c     Bucle que nos calcula el rbol de t(k,i)                                    
           h=h/2
              v=0
          
           do n=1,2**(k-1)
             call g(a+(2*n-1)*h,d,c,f)
             v=v+f
           enddo
            t(k,0)=t(k-1,0)/2+h*v
            do i=1,k
              t(k,i)=(4**i)*t(k,i-1)-t(k-1,i-1)
              t(k,i)=t(k,i)/((4**i)-1)
            enddo    
   
        e(k)=abs(1-t(k-1,k-1)/t(k,k))
        
c     Clculo de los ratios    
        do i=0,k-2
          r(k,i)=t(k-1,i)-t(k-2,i)
          r(k,i)=r(k,i)/(t(k,i)-t(k-1,i))
        enddo
     
c     Criterio de parada y presentacin de resultados   
         if(e(k).le.eps) then
            
            write(17,*) 'Tablas de valores de la segunda prctica'
            do i=1,3
              write(17,*)
            enddo
            
            write(17,*) 'rbol de t(k,i)'
            write(17,*) '_______________'
            write(17,'(5x,7(4x,i1,4x))') (i,i=0,k)
            
            write(*,*) 'Arbol de t(k,i)'
            write(*,'(5x,7(4x,i1,4x))') (i,i=0,k)
            
            do i=0,k
              write(17,'(i1,4x,7(f8.6,1x))') i,(t(i,j), j=0,i)  
              write(*,'(i1,4x,7(f8.6,1x))') i,(t(i,j), j=0,i)
            enddo
            pause
            do i=1,3
              write(17,*)
            enddo
            
              write(17,*) 'ratios'
              write(17,*) '____________________________' 
              write(17,'(5x,5(7x,i1,6x))') (i,i=0,k-2)
            
              write(*,*) 'ratios'
              write(*,'(5x,5(7x,i1,6x))') (i,i=0,k-2)
            
            do i=2,k
              write(17,'(i1,4x,5(f13.8,1x))') i,(r(i,j), j=0,i-2) 
              write(*,'(i1,4x,5(f13.8,1x))') i,(r(i,j), j=0,i-2)
            enddo
            pause
            do i=1,3
              write(17,*)
            enddo
            
            write(17,*) 'Tabla de valores t(k,k)'
            write(17,*) '_______________________'
            write(17,'(a1,3x,4x,a6,8x,a5,4x)') 'k','t(k,k)','error' 
            write(17,*) 
            
            write(*,*) 'Tabla de valores t(k,k)'
            write(*,'(a1,3x,4x,a6,7x,a5,4x)') 'k','t(k,k)','error'
            
            write(17,'(i1,3x,f12.9,1x)') 0,t(0,0) 
            write(*,'(i1,3x,f12.9,1x)') 0,t(0,0)
            
            do i=1,k
              write(17,'(i1,3x,f12.9,1x,e13.7)') i,t(i,i),e(i)
              write(*,'(i1,3x,f12.9,1x,e13.7)') i,t(i,i),e(i) 
            enddo
            pause
            do i=1,3
              write(17,*)
            enddo
            
            write(17,'(a23,f13.10)') 'VALOR DE LA INTEGRAL =',t(k,k)
            
            write(*,'(a23,f13.10)') 'VALOR DE LA INTEGRAL =',t(k,k)
            pause
            
            write(17,*)
          write(17,*) 'Comparacin de valores'
          write(17,*)
          write(17,*) 'Error relativo entre las aproximaciones:'
          write(17,*)
          write(17,*) 'De Romberg y del Trapecio:'
       write(17,'(3x,a8,f13.10)') 'error = ',abs((t(0,0)-t(k,k))/t(k,k))
          write(17,*)
          write(17,*) 'De Romberg y de Simpson:'
       write(17,'(3x,a8,f13.10)') 'error = ',abs((t(1,1)-t(k,k))/t(k,k)) 
       
       write(*,*) 'Comparacion de valores'
          write(*,*)
          write(*,*) 'Error relativo entre las aproximaciones:'
          write(*,*)
          write(*,*) 'De Romberg y del Trapecio:'
       write(*,'(3x,a8,f13.10)') 'error = ',abs((t(0,0)-t(k,k))/t(k,k))
          write(*,*)
          write(*,*) 'De Romberg y de Simpson:'
       write(*,'(3x,a8,f13.10)') 'error = ',abs((t(1,1)-t(k,k))/t(k,k))
         
         stop
        endif       
                
      enddo       
            
       close(17)
      
      end              
      
c     Subrutina que aplica el mtodo de Simpson para calcular f     
      subroutine g(l,d,c,f)
      
      real*8 c,d,l,eps,t(100),s(100),h,sum,fi,e(100),f
      integer i,k,kmax
      parameter (eps=5e-11,kmax=30)
      
      h=c-d
            
      t(0)=h*(fi(l,d)+fi(l,c))/2
      
      
      h=h/2
      t(1)=t(0)/2+h*(fi(l,d+h))
      s(1)=(4*t(1)-t(0))/3
        do k=2,kmax
           h=h/2
           sum=0
              do i=1,2**(k-1)
                sum=sum+fi(l,d+(2*i-1)*h)
              enddo
              
        t(k)=t(k-1)/2+h*sum

        s(k)=4*t(k)-t(k-1)
        s(k)=s(k)/3       

        e(k)=abs(s(k)-s(k-1))
        e(k)=e(k)/abs(s(k))  
         
         if(e(k).lt.eps) then
          f=s(k)
          return
         endif
        enddo  
      end               
      
      real*8 function fi(l,x)
      
        real*8 x,l
        
        fi=exp(-(1+l*x)*cos(x))
        return
      end